﻿using System;
using System.Diagnostics;

class Program
{
    static void Main(string[] args)
    {
        Action<int, string, Action<int, string>, string> action = (loopCount, title, work, arg) =>
        {
            Stopwatch st = new Stopwatch();
            st.Start();

            work(loopCount, arg);

            st.Stop();

            Console.WriteLine(title + " : " + st.ElapsedMilliseconds);
        };

        action(1, "ConcatText for JIT", ConcatText, "");
        action(1, "InterpolateText for JIT", InterpolateText, "");
        action(1, "FormatText for JIT", FormatText, "");

        Console.WriteLine();

        action(10000000, "ConcatText", ConcatText, "");
        action(10000000, "InterpolateText", InterpolateText, "");
        action(10000000, "FormatText", FormatText, "");
    }

    private static void ConcatText(int loopCount, string text)
    {
        for (int i = 0; i < loopCount; i++)
        {
            TestLog(text + "a");
        }
    }

    private static void InterpolateText(int loopCount, string text)
    {
        for (int i = 0; i < loopCount; i++)
        {
            TestLog($"{text}a");
        }
    }

    private static void FormatText(int loopCount, string text)
    {
        for (int i = 0; i < loopCount; i++)
        {
            // TestLog("{0}a", text);
            TestLog(string.Format("{0}a", text));
        }
    }

    // release 빌드에서는, 빈 메서드인 TestLog에 대한 호출은 JIT 컴파일 시 제거됩니다.
    static void TestLog(string format, params object[] args)
    {
    }
}
